/////////////////////////////// Vertex shader
#version 120

attribute vec4 iVS_Position;
attribute vec4 iVS_Normal;
attribute vec2 iVS_UV;
attribute vec4 iVS_Tangent;
attribute vec4 iVS_Binormal;

varying vec3 iFS_Normal;
varying vec2 iFS_UV;
varying vec3 iFS_Tangent;
varying vec3 iFS_Binormal;
varying vec3 iFS_PointWS;

uniform mat4 matWorld;
uniform mat4 matWorldViewProjection;
uniform mat4 matWorldInverseTranspose;

void main()
{
    gl_Position = matWorldViewProjection * iVS_Position;
    iFS_Normal = (matWorldInverseTranspose * iVS_Normal).xyz;
    iFS_UV = iVS_UV;
    iFS_Tangent = (matWorldInverseTranspose * iVS_Tangent).xyz;
    iFS_Binormal = (matWorldInverseTranspose * iVS_Binormal).xyz;
    iFS_PointWS = (matWorld * iVS_Position).xyz;
}
